VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsGLext_APPLE"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function wglGetProcAddress Lib "opengl32.dll" (lpStr As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal ByteLen As Long)
Private Declare Function VirtualProtect Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flNewProtect As Long, lpflOldProtect As Long) As Long
Private Const PAGE_EXECUTE_READWRITE = &H40&

Public Sub glElementPointerAPPLE(ByVal ltype As Long, ByVal pointer As Long): End Sub
Public Sub glDrawElementArrayAPPLE(ByVal mode As Long, ByVal first As Long, ByVal count As Long): End Sub
Public Sub glDrawRangeElementArrayAPPLE(ByVal mode As Long, ByVal start As Long, ByVal lend As Long, ByVal first As Long, ByVal count As Long): End Sub
Public Sub glMultiDrawElementArrayAPPLE(ByVal mode As Long, ByRef first As Long, ByRef count As Long, ByVal primcount As Long): End Sub
Public Sub glMultiDrawRangeElementArrayAPPLE(ByVal mode As Long, ByVal start As Long, ByVal lend As Long, ByRef first As Long, ByRef count As Long, ByVal primcount As Long): End Sub
Public Sub glGenFencesAPPLE(ByVal n As Long, ByRef fences As Long): End Sub
Public Sub glDeleteFencesAPPLE(ByVal n As Long, ByRef fences As Long): End Sub
Public Sub glSetFenceAPPLE(ByVal fence As Long): End Sub
Public Function glIsFenceAPPLE(ByVal fence As Long) As Long: End Function
Public Function glTestFenceAPPLE(ByVal fence As Long) As Long: End Function
Public Sub glFinishFenceAPPLE(ByVal fence As Long): End Sub
Public Function glTestObjectAPPLE(ByVal object As Long, ByVal name As Long) As Long: End Function
Public Sub glFinishObjectAPPLE(ByVal object As Long, ByVal name As Long): End Sub
Public Sub glBindVertexArrayAPPLE(ByVal larray As Long): End Sub
Public Sub glDeleteVertexArraysAPPLE(ByVal n As Long, ByRef arrays As Long): End Sub
Public Sub glGenVertexArraysAPPLE(ByVal n As Long, ByRef arrays As Long): End Sub
Public Function glIsVertexArrayAPPLE(ByVal larray As Long) As Long: End Function
Public Sub glVertexArrayRangeAPPLE(ByVal length As Long, ByVal pointer As Long): End Sub
Public Sub glFlushVertexArrayRangeAPPLE(ByVal length As Long, ByVal pointer As Long): End Sub
Public Sub glVertexArrayParameteriAPPLE(ByVal pname As Long, ByVal param As Long): End Sub
 
Private Function ReplaceVtableEntry(ByVal entry As Integer, ByVal lpfn As Long) As Long
    Dim lOldAddr As Long
    Dim lpVtableHead As Long
    Dim lpfnAddr As Long
    Dim lOldProtect As Long
    CopyMemory lpVtableHead, ByVal ObjPtr(Me), 4
    lpfnAddr = lpVtableHead + (entry - 1) * 4
    CopyMemory lOldAddr, ByVal lpfnAddr, 4 'Get old entry
    If lOldAddr <> lpfn Then
        VirtualProtect lpfnAddr, 4, PAGE_EXECUTE_READWRITE, lOldProtect
        CopyMemory ByVal lpfnAddr, lpfn, 4
        'Dont bother to reprotect
        VirtualProtect lpfnAddr, 4, lOldProtect, lOldProtect
    End If
    ReplaceVtableEntry = lOldAddr
End Function
Private Function ReplaceEntryWithDLLFunction(ByVal entry As Integer, ByVal lpfn As Long) As Long
    Dim lFuncAddr As Long
    Dim lpVtableHead As Long
    Dim lpfnAddr As Long
    Dim lOldProtect As Long
    
    CopyMemory lpVtableHead, ByVal ObjPtr(Me), 4
    lpfnAddr = lpVtableHead + (entry - 1) * 4
    CopyMemory lFuncAddr, ByVal lpfnAddr, 4 'Get old entry
    If lFuncAddr <> lpfn Then
        VirtualProtect lFuncAddr, 10, PAGE_EXECUTE_READWRITE, lOldProtect
        
        CopyMemory ByVal lFuncAddr, &HB824048F, 4 'pop [esp] 'mov eax,
        CopyMemory ByVal lFuncAddr + 4, lpfn, 4
        CopyMemory ByVal lFuncAddr + 8, &HE0FF, 2
        
        'Dont bother to reprotect
        VirtualProtect lFuncAddr, 10, lOldProtect, lOldProtect
    End If
    ReplaceEntryWithDLLFunction = lFuncAddr
End Function
Private Sub Class_Initialize()
    Dim lProcAddress As Long
    Dim entry As Long
    Dim sFunctionName As String
    Dim bData() As Byte
    Dim i As Long
    '8 is the first entry
    entry = 8
     
    bData = LoadResData("APPLE", "GLEXT")
    For i = 0 To UBound(bData) - 1
        If bData(i) = 0 Then
            lProcAddress = wglGetProcAddress(bData(i + 1))
            If lProcAddress Then ReplaceEntryWithDLLFunction entry, lProcAddress
            entry = entry + 1
        ElseIf i = 0 Then
            lProcAddress = wglGetProcAddress(bData(i))
            If lProcAddress Then ReplaceEntryWithDLLFunction entry, lProcAddress
            entry = entry + 1
        End If
    Next i
End Sub

