VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsGLext_Others"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function wglGetProcAddress Lib "opengl32.dll" (lpStr As Any) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSource As Any, ByVal ByteLen As Long)
Private Declare Function VirtualProtect Lib "kernel32" (ByVal lpAddress As Long, ByVal dwSize As Long, ByVal flNewProtect As Long, lpflOldProtect As Long) As Long
Private Const PAGE_EXECUTE_READWRITE = &H40&

Public Sub glVertexPointervINTEL(ByVal size As Long, ByVal ltype As Long, ByVal pointer As Long): End Sub
Public Sub glNormalPointervINTEL(ByVal ltype As Long, ByVal pointer As Long): End Sub
Public Sub glColorPointervINTEL(ByVal size As Long, ByVal ltype As Long, ByVal pointer As Long): End Sub
Public Sub glTexCoordPointervINTEL(ByVal size As Long, ByVal ltype As Long, ByVal pointer As Long): End Sub

Public Sub glResizeBuffersMESA(void): End Sub
Public Sub glWindowPos2dMESA(ByVal x As Double, ByVal y As Double): End Sub
Public Sub glWindowPos2dvMESA(ByRef v As Double): End Sub
Public Sub glWindowPos2fMESA(ByVal x As Single, ByVal y As Single): End Sub
Public Sub glWindowPos2fvMESA(ByRef v As Single): End Sub
Public Sub glWindowPos2iMESA(ByVal x As Long, ByVal y As Long): End Sub
Public Sub glWindowPos2ivMESA(ByRef v As Long): End Sub
Public Sub glWindowPos2sMESA(ByVal x As Integer, ByVal y As Integer): End Sub
Public Sub glWindowPos2svMESA(ByRef v As Integer): End Sub
Public Sub glWindowPos3dMESA(ByVal x As Double, ByVal y As Double, ByVal z As Double): End Sub
Public Sub glWindowPos3dvMESA(ByRef v As Double): End Sub
Public Sub glWindowPos3fMESA(ByVal x As Single, ByVal y As Single, ByVal z As Single): End Sub
Public Sub glWindowPos3fvMESA(ByRef v As Single): End Sub
Public Sub glWindowPos3iMESA(ByVal x As Long, ByVal y As Long, ByVal z As Long): End Sub
Public Sub glWindowPos3ivMESA(ByRef v As Long): End Sub
Public Sub glWindowPos3sMESA(ByVal x As Integer, ByVal y As Integer, ByVal z As Integer): End Sub
Public Sub glWindowPos3svMESA(ByRef v As Integer): End Sub
Public Sub glWindowPos4dMESA(ByVal x As Double, ByVal y As Double, ByVal z As Double, ByVal w As Double): End Sub
Public Sub glWindowPos4dvMESA(ByRef v As Double): End Sub
Public Sub glWindowPos4fMESA(ByVal x As Single, ByVal y As Single, ByVal z As Single, ByVal w As Single): End Sub
Public Sub glWindowPos4fvMESA(ByRef v As Single): End Sub
Public Sub glWindowPos4iMESA(ByVal x As Long, ByVal y As Long, ByVal z As Long, ByVal w As Long): End Sub
Public Sub glWindowPos4ivMESA(ByRef v As Long): End Sub
Public Sub glWindowPos4sMESA(ByVal x As Integer, ByVal y As Integer, ByVal z As Integer, ByVal w As Integer): End Sub
Public Sub glWindowPos4svMESA(ByRef v As Integer): End Sub

Public Sub glMultiModeDrawArraysIBM(ByRef mode As Long, ByRef first As Long, ByRef count As Long, ByVal primcount As Long, ByVal modestride As Long): End Sub
Public Sub glMultiModeDrawElementsIBM(ByRef mode As Long, ByRef count As Long, ByVal ltype As Long, ByVal pindices As Long, ByVal primcount As Long, ByVal modestride As Long): End Sub
Public Sub glColorPointerListIBM(ByVal size As Long, ByVal ltype As Long, ByVal stride As Long, ByVal pointer As Long, ByVal ptrstride As Long): End Sub
Public Sub glSecondaryColorPointerListIBM(ByVal size As Long, ByVal ltype As Long, ByVal stride As Long, ByVal pointer As Long, ByVal ptrstride As Long): End Sub
Public Sub glEdgeFlagPointerListIBM(ByVal stride As Long, ByVal pointer As Long, ByVal ptrstride As Long): End Sub
Public Sub glFogCoordPointerListIBM(ByVal ltype As Long, ByVal stride As Long, ByVal pointer As Long, ByVal ptrstride As Long): End Sub
Public Sub glIndexPointerListIBM(ByVal ltype As Long, ByVal stride As Long, ByVal pointer As Long, ByVal ptrstride As Long): End Sub
Public Sub glNormalPointerListIBM(ByVal ltype As Long, ByVal stride As Long, ByVal pointer As Long, ByVal ptrstride As Long): End Sub
Public Sub glTexCoordPointerListIBM(ByVal size As Long, ByVal ltype As Long, ByVal stride As Long, ByVal pointer As Long, ByVal ptrstride As Long): End Sub
Public Sub glVertexPointerListIBM(ByVal size As Long, ByVal ltype As Long, ByVal stride As Long, ByVal pointer As Long, ByVal ptrstride As Long): End Sub
 
Public Sub glImageTransformParameteriHP(ByVal target As Long, ByVal pname As Long, ByVal param As Long): End Sub
Public Sub glImageTransformParameterfHP(ByVal target As Long, ByVal pname As Long, ByVal param As Single): End Sub
Public Sub glImageTransformParameterivHP(ByVal target As Long, ByVal pname As Long, ByRef params As Long): End Sub
Public Sub glImageTransformParameterfvHP(ByVal target As Long, ByVal pname As Long, ByRef params As Single): End Sub
Public Sub glGetImageTransformParameterivHP(ByVal target As Long, ByVal pname As Long, ByRef params As Long): End Sub
Public Sub glGetImageTransformParameterfvHP(ByVal target As Long, ByVal pname As Long, ByRef params As Single): End Sub

Public Sub glTbufferMask3DFX(ByVal mask As Long): End Sub
Public Sub glStringMarkerGREMEDY(ByVal llen As Long, ByVal pstring As Long): End Sub


Private Function ReplaceVtableEntry(ByVal entry As Integer, ByVal lpfn As Long) As Long
    Dim lOldAddr As Long
    Dim lpVtableHead As Long
    Dim lpfnAddr As Long
    Dim lOldProtect As Long
    CopyMemory lpVtableHead, ByVal ObjPtr(Me), 4
    lpfnAddr = lpVtableHead + (entry - 1) * 4
    CopyMemory lOldAddr, ByVal lpfnAddr, 4 'Get old entry
    If lOldAddr <> lpfn Then
        VirtualProtect lpfnAddr, 4, PAGE_EXECUTE_READWRITE, lOldProtect
        CopyMemory ByVal lpfnAddr, lpfn, 4
        'Dont bother to reprotect
        VirtualProtect lpfnAddr, 4, lOldProtect, lOldProtect
    End If
    ReplaceVtableEntry = lOldAddr
End Function
Private Function ReplaceEntryWithDLLFunction(ByVal entry As Integer, ByVal lpfn As Long) As Long
    Dim lFuncAddr As Long
    Dim lpVtableHead As Long
    Dim lpfnAddr As Long
    Dim lOldProtect As Long
    
    CopyMemory lpVtableHead, ByVal ObjPtr(Me), 4
    lpfnAddr = lpVtableHead + (entry - 1) * 4
    CopyMemory lFuncAddr, ByVal lpfnAddr, 4 'Get old entry
    If lFuncAddr <> lpfn Then
        VirtualProtect lFuncAddr, 10, PAGE_EXECUTE_READWRITE, lOldProtect
        
        CopyMemory ByVal lFuncAddr, &HB824048F, 4 'pop [esp] 'mov eax,
        CopyMemory ByVal lFuncAddr + 4, lpfn, 4
        CopyMemory ByVal lFuncAddr + 8, &HE0FF, 2
        
        'Dont bother to reprotect
        VirtualProtect lFuncAddr, 10, lOldProtect, lOldProtect
    End If
    ReplaceEntryWithDLLFunction = lFuncAddr
End Function
Private Sub Class_Initialize()
    Dim lProcAddress As Long
    Dim entry As Long
    Dim sFunctionName As String
    Dim bData() As Byte
    Dim i As Long
    '8 is the first entry
    entry = 8
     
    bData = LoadResData("OTHERS", "GLEXT")
    For i = 0 To UBound(bData) - 1
        If bData(i) = 0 Then
            lProcAddress = wglGetProcAddress(bData(i + 1))
            If lProcAddress Then ReplaceEntryWithDLLFunction entry, lProcAddress
            entry = entry + 1
        ElseIf i = 0 Then
            lProcAddress = wglGetProcAddress(bData(i))
            If lProcAddress Then ReplaceEntryWithDLLFunction entry, lProcAddress
            entry = entry + 1
        End If
    Next i
End Sub




